<HTML>
<HEAD>
<TITLE>HEPiX Scripts - Internals</TITLE>
<!-- Changed by: Lionel Cons,  5-Nov-1996 -->
<!-- TODO: document SUE tools, other directories and files -->
</HEAD>
<BODY>

<H1>HEPiX Scripts - Internals</H1>

<P> Here are some internal details about the
<A HREF="../">HEPiX scripts</A>.

<P> <HR> <P>

<H1>Master Repository</H1>

<P> The master repository for the HEPiX scripts is in AFS
under <CODE>/afs/cern.ch/project/hepix/working-groups/scripts</CODE>.

<P> Terminology:
<UL>
<LI> the source files (in <CODE>src</CODE>) contain pre-processing options for the tool
     <CODE>pp</CODE> including OS dependent parts or command names from the dictionaries
<LI> the compiled files (in <CODE>comp</CODE>) contain only few "meta" variables
     that will be replaced at installation time only, they are defined in <CODE>default.s</CODE>:
<PRE>
TOP             /usr/local/lib/hepix
TOP_SYSTEM      /etc/hepix
TOP_CLUSTER     /etc/hepix/cluster
TOP_USER        $HOME/.hepix
TOP_GROUP       $GROUP_DIR
TOP_XDM         /usr/sue/lib/xdm/hepix
perl            /usr/local/bin/perl5
</PRE>
</UL>

<P> Conventions:
<UL>
<LI> <VAR>&lt;pkg&gt;</VAR>: a package name, currently only
     <SAMP>X11</SAMP>, <SAMP>X11-cern</SAMP>,
     <SAMP>shells</SAMP>, <SAMP>shells-cern</SAMP> or <SAMP>uco</SAMP>
<LI> <VAR>&lt;ver&gt;</VAR>: a package version
<LI> <VAR>&lt;sys&gt;</VAR>: an identifier of the operating system
     usually the AFS @sys value
<LI> <VAR>&lt;util&gt;</VAR>: a utility name, for instance
     <SAMP>is_hepix</SAMP>, <SAMP>xinfo</SAMP>, <SAMP>xmessage</SAMP>...
</UL>

<P> The relevant subdirectories are:
<UL>
<LI> <CODE>comp</CODE>: compiled files
  <UL>
  <LI> <VAR>&lt;pkg&gt;</VAR>/<VAR>&lt;ver&gt;</VAR>/<VAR>&lt;sys&gt;</VAR>:
       all the files of the specified package version
  <LI> utils/<VAR>&lt;util&gt;</VAR>: the latest version of the given utility,
       usually with different binaries named <VAR>&lt;name&gt;</VAR>.<VAR>&lt;sys&gt;</VAR>
  </UL>
<LI> <CODE>doc</CODE> (aka <CODE>www</CODE>): all the documentation,
     mainly in HTML format, accessible from
     <A HREF="http://wwwinfo.cern.ch/hepix/wg/scripts/www/">
     <CODE>http://wwwinfo.cern.ch/hepix/wg/scripts/www/</CODE></A>
<LI> <CODE>src</CODE>: source tree
  <UL>
  <LI> <VAR>&lt;pkg&gt;</VAR>/<VAR>&lt;ver&gt;</VAR>: the sources of the
       specified package version
  <LI> utils/<VAR>&lt;util&gt;</VAR>: the latest version of the sources of
       the given utility
  </UL>
<LI> <CODE>tools</CODE>: internals tools for the HEPiX scripts,
     described below
<LI> <CODE>unpack</CODE>: ready-to-use files in SALAD format under 
     <VAR>&lt;pkg&gt;</VAR>-<VAR>&lt;ver&gt;</VAR>
</UL>

<H2>Internal Tools</H2>

<P> High-level tools:
<DL>
<DT> <CODE>compile [-noprep] [-wipeout] <VAR>&lt;util&gt;</VAR> [where...]</CODE>
<DD> compile the named utility on the given machine(s) (or locally by default),
     <CODE>where</CODE> can be 'all';
     <CODE>-noprep</CODE> skips the preparation phase
         (create the directories, create the symbolic links...);
     <CODE>-wipeout</CODE> removes everything under
     <CODE>comp/utils/<VAR>&lt;util&gt;</VAR></CODE> before compiling
<DT> <CODE>compile-src -<VAR>&lt;pkg&gt;</VAR> [build-flags] <VAR>&lt;ver&gt;</VAR> <VAR>&lt;sys&gt;</VAR>...</CODE>
<DD> compile (i.e. from <CODE>src</CODE> to <CODE>comp</CODE>)
     the given version of a package for the given <VAR>&lt;sys&gt;</VAR> (can be 'all')
<DT> <CODE>prepare -<VAR>&lt;pkg&gt;</VAR> [-dst dir] [build-flags] <VAR>&lt;ver&gt;</VAR> <VAR>&lt;sys&gt;</VAR>...</CODE>
<DD> prepare (i.e. replace the meta-variables in <CODE>comp</CODE>)
     the given version of a package for the given <VAR>&lt;sys&gt;</VAR> (can be 'all');
     <CODE>-dst</CODE> can be 'asis'
	(will end up under <CODE>/afs/.cern.ch/asis/packages/HEPiX/...</CODE>)
     or 'unpack'
	(will end up under <CODE>unpack/<VAR>&lt;pkg&gt;</VAR>-<VAR>&lt;ver&gt;</VAR></CODE>)
     or a real directory
</DL>

<P> Low-level tools:
<DL>
<DT> <CODE>build [-d] [-f] [-n] [-sys sys] src_dir dst_dir</CODE>
<DD> call <CODE>pp</CODE> recursively on the tree under <CODE>src_dir</CODE>
     and put the processed files under <CODE>dst_dir</CODE>;
     the given <CODE>sys</CODE> will be used to choose a dictionary;
     <CODE>src_dir/build.cfg</CODE> will be used to customise the task,
     for more info RTSL!
<DT> <CODE>csh2sh [csh-script [sh-script]]</CODE>
<DD> a simple-minded program to convert some C shell scripts to Bourne shell syntax
<DT> <CODE>pp [-d] [-o name] [-s file] [-i file] [-S expr] [-D expr] file</CODE>
<DD> a simple (?) general purpose pre-processor taking a file name and
     spitting out the result on stdout; it usually replaces the strings of the
     form <SAMP>$[foo]</SAMP> and handles the directives starting with <SAMP>:foo</SAMP>;
     for more information, read the program!
</DL>

<H2>Dictionaries</H2>

<P> <CODE>compile-src</CODE> requires dictionaries that contain, for each supported
<VAR>&lt;sys&gt;</VAR>, a mapping between command names and full paths
(e.g. <CODE>chmod</CODE> -&gt; <CODE>/bin/chmod</CODE>).

<P> The dictionaries (as well as the related manipulation programs)
are stored in the <CODE>dico</CODE> subdirectory of
<CODE>tools</CODE>. The name of a dictionary is simply <VAR>&lt;sys&gt;</VAR>.

<P> The dictionaries contain building information (who, when,
where...) and a log file (named <CODE>log</CODE>) keeps track of all
the changes made to the dictionaries.

<P> The manipulation programs are:
<DL>
<DT> <CODE>build [-o file] [-p path] [template]</CODE>
<DD> to build a dictionary from the given path (or $PATH by default)
     and a given template - list of commands - (or stdin by default)
     and put it in the given file (or stdout by default);
     it also stores the AFS @sys
<DT> <CODE>check [dico]</CODE>
<DD> to check all the paths apperaing in the given dictionary
     (or AFS' @sys by default)
<DT> <CODE>store [-n] dico...</CODE>
<DD> to store the given list of dictionaries (<CODE>-n</CODE> means show only the differences)
     in the current working directory; the names are taken from the AFS' @sys
     stored in the files and the changes are logged
<DT> <CODE>usage [-v] dir</CODE>
<DD> to check all the files under the given directory and report all the
     things looking like dictionary command names (i.e. <SAMP>$[foo]</SAMP>);
     <CODE>-v</CODE> means show also the line where the command appears
</DL>

<P> For instance, one would probably do something like:
<PRE>
# build a dico using current $PATH
host1&gt; ./build -o test1 template
# build a dico using default (hard-coded) $PATH
host1&gt; ./build -o test2 -p 0 template
# check the result
host1&gt; diff test1 test2
# check that the commands exist on another machine
host2&gt; ./check test
# see the differences with the current dictionary
host1&gt; ./store -n test
# really store the dico
host1&gt; ./store test
</PRE>

<P> <HR> <P>

<ADDRESS>
<A HREF="http://wwwinfo.cern.ch/~cons">Lionel Cons</A>,  5-Nov-1996
</ADDRESS>

</BODY>
</HTML>
